NaiveBayesModel (Apache OpenNLP Tools 1.9.5 API)
Date: 2026-06-18

opennlp.tools.ml.naivebayes

## Class NaiveBayesModel

- java.lang.Object
- - opennlp.tools.ml.model.AbstractModel
  - - opennlp.tools.ml.naivebayes.NaiveBayesModel

- All Implemented Interfaces:
    MaxentModel

      public class NaiveBayesModel
      extends AbstractModel

  Class implementing the multinomial Naive Bayes classifier model.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class opennlp.tools.ml.model.AbstractModel

      `AbstractModel.ModelType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NaiveBayesModel(Context[] params, String[] predLabels, String[] outcomeNames)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static double[]` | `eval(int[] context, double[] prior, EvalParameters model)`
    `double[]` | `eval(String[] context)` Evaluates a context.
    `double[]` | `eval(String[] context, double[] probs)` Evaluates a context.
    `double[]` | `eval(String[] context, float[] values)` Evaluates a contexts with the specified context values.
    `double[]` | `eval(String[] context, float[] values, double[] outsums)`

    - ### Methods inherited from class opennlp.tools.ml.model.AbstractModel

      `equals, getAllOutcomes, getBestOutcome, getDataStructures, getIndex, getModelType, getNumOutcomes, getOutcome, hashCode`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NaiveBayesModel

          public NaiveBayesModel(Context[] params,
                                 String[] predLabels,
                                 String[] outcomeNames)

  - ### Method Detail

    - #### eval

          public double[] eval(String[] context)

      Description copied from interface: `MaxentModel`
      Evaluates a context.
      Parameters:
        `context` - A list of String names of the contextual predicates which are to be evaluated together.
      Returns:
        an array of the probabilities for each of the different outcomes, all of which sum to 1.

    - #### eval

          public double[] eval(String[] context,
                               float[] values)

      Description copied from interface: `MaxentModel`
      Evaluates a contexts with the specified context values.
      Parameters:
        `context` - A list of String names of the contextual predicates which are to be evaluated together.
        `values` - The values associated with each context.
      Returns:
        an array of the probabilities for each of the different outcomes, all of which sum to 1.

    - #### eval

          public double[] eval(String[] context,
                               double[] probs)

      Description copied from interface: `MaxentModel`
      Evaluates a context.
      Parameters:
        `context` - A list of String names of the contextual predicates which are to be evaluated together.
        `probs` - An array which is populated with the probabilities for each of the different outcomes, all of which sum to 1.
      Returns:
        an array of the probabilities for each of the different outcomes, all of which sum to 1.

    - #### eval

          public double[] eval(String[] context,
                               float[] values,
                               double[] outsums)

    - #### eval

          public static double[] eval(int[] context,
                                      double[] prior,
                                      EvalParameters model)

Copyright © 2026 The Apache Software Foundation. All rights reserved.